#include <stdio.h>
#include <string.h>

#define PRINT_DATA 1

// In C, enums more or less define constants the same way #define would
enum quests {
  Q1 = 1, Q2 = 2, Q3 = 4, Q4 = 8, Q5 = 16
};

typedef struct data_t {
  // 16 bytes
  char name[16];
  // 4 bytes
  unsigned int exp : 27;
  char qsts : 5;
  // 1 byte
  unsigned char lev : 7;
  char hard : 1;
} data_t;

int main(int argc, char **argv) {
  printf("Size of data struct: %hu bytes\n", sizeof(data_t));
  data_t data;
  data_t *d = &data;
  strncpy(d->name, "xxRadHorsexx", 15);
  d->name[15] = '\0';
  d->lev = 98;
  d->hard = 1;
  d->exp = 84140915;
  d->qsts = Q1 | Q2 | Q4;
  if (PRINT_DATA)
    printf("\nName: %s\nLevel: %u\nHardcore: %s\nExperience: %u\nQuests: "
	   "0x%x\n", d->name, d->lev, d->hard ? "True" : "False",
	   d->exp, d->qsts);
  
  return 0;
}
